<script setup lang="ts">
    import { Equipement } from '@/interventionServiceOffer/entities/equipement/Equipement'
    import { isDefined } from '@/shared/helpers/types'

    withDefaults(
        defineProps<{
            equipement?: Equipement
            onlyDisplayAncetres?: boolean
        }>(),
        {
            equipement: undefined,
            onlyDisplayAncetres: false,
        }
    )
    defineEmits<{
        (
            e: 'selectEquipementAncetre',
            equipementId: Equipement['id'] | undefined
        ): void
        (e: 'selectDernierEquipement', equipementId: Equipement['id']): void
    }>()
</script>

<template>
    <p class="text-body-2" style="font-size: 0.9em !important">
        <template v-if="equipement?.hasLignéeAncetres()">
            <span
                v-for="(lignée, idLignée) in equipement.ancetres"
                :key="idLignée"
                :data-cy="`breadcrumb-${idLignée}`"
            >
                <span v-if="!onlyDisplayAncetres">
                    <a
                        class="cursor-pointer text-secondary"
                        @click="$emit('selectEquipementAncetre', undefined)"
                    >
                        <v-icon>mdi-home-outline</v-icon>
                    </a>
                    /
                </span>
                <template v-for="(ancêtre, index) in lignée" :key="ancêtre.id">
                    <span class="d-inline-block text-no-wrap">
                        <a
                            class="cursor-pointer text-truncate"
                            :class="{
                                'text-secondary': !onlyDisplayAncetres,
                            }"
                            style="
                                max-width: 9em;
                                vertical-align: middle;
                                display: inline-block;
                            "
                            :data-cy="ancêtre.id"
                            @click="
                                $emit('selectEquipementAncetre', ancêtre.id)
                            "
                        >
                            {{ ancêtre.label }}
                        </a>
                        <template
                            v-if="
                                index < lignée.length - 1 ||
                                !onlyDisplayAncetres
                            "
                            >&nbsp;/&nbsp;</template
                        >
                    </span>
                </template>
                <span
                    v-if="!onlyDisplayAncetres"
                    class="d-inline-block text-truncate"
                    style="max-width: 9em; vertical-align: middle"
                >
                    <a
                        class="cursor-pointer"
                        @click="$emit('selectDernierEquipement', equipement.id)"
                    >
                        {{ equipement.label }}
                    </a>
                </span>
            </span>
        </template>

        <span v-else>
            <span v-if="!onlyDisplayAncetres">
                <a
                    class="cursor-pointer text-secondary"
                    @click="$emit('selectEquipementAncetre', undefined)"
                >
                    <v-icon>mdi-home-outline</v-icon>
                </a>
            </span>
            <span v-if="isDefined(equipement) && !onlyDisplayAncetres">
                /&nbsp;
                <a
                    class="cursor-pointer"
                    @click="$emit('selectDernierEquipement', equipement.id)"
                >
                    {{ equipement.label }}
                </a>
            </span>
        </span>
    </p>
</template>
